const {ccclass, property} = cc._decorator;

@ccclass
export default class Locale {
    private static locale = 'EN'

    public static setLocale(locale: string): void {
        if (['en_GB' ,'en_PI' ,'en_UD' ,'en_US', 'en_VN'].includes(locale)) locale = 'EN'
        if (['zh_CN' ,'zh_HK' ,'zh_TW'].includes(locale)) locale = 'CN'
        if (['ja_JP', 'ja_KS'].includes(locale)) locale = 'JP'
        if (['es_ES', 'es_LA', 'es_MX'].includes(locale)) locale = 'ES'
        if (['pt_BR', 'pt_PT'].includes(locale)) locale = 'PT'
        if (!Object.keys(LOCALE_MAPPING).includes(locale)) locale = 'EN'
        Locale.locale = locale
    }

    public static getLocale(): string {
        return Locale.locale
    }

    public static getText(txt: string): string {
        return LOCALE_MAPPING[Locale.locale][txt.toLowerCase()]
    }
}


const LOCALE_MAPPING = {
    'EN': {
        'completed': 'completed',
        'next': 'next',
        'level': 'level',
        'levels': 'levels',
        'tap to start': 'tap to start',
        'setting': 'setting',
        'sound': 'sound',
        'music': 'music',
        'select level': 'select level',
        'continue': 'continue',
        'guideoption': "Oh No! Lupin's lover has been kidnapped! Choose 1 of the options below to help him chase the kidnapper!",
        'guidefocusopt': "Hm! Looks like our previous selection was incorrect. Let's choose the other one.",
        'guidefinal': "Wow! Looks like we'll catch up. Let's continue to explore the rest of the story.",
        'guidefreesave': "Oh No! Looks like the last choice was incorrect. Save Lupin or we will have to start over from the beginning of the level.",
        'guidehint': "If you just want to pass, then use hints to help you through.",
    },
    'vi_VN': {
        'completed': 'hoàn thành',
        'next': 'tiếp',
        'level': 'level',
        'levels': 'levels',
        'tap to start': 'bấm để chơi',
        'setting': 'cài đặt',
        'sound': 'âm thanh',
        'music': 'âm nhạc',
        'select level': 'chọn level',
        'continue': 'tiếp tục',
        'guideoption': "Ôi không! Người yêu của Lupin đã bị bắt cóc! Hãy chọn 1 trong các phương án dưới đây để giúp anh ấy đuổi theo kẻ bắt cóc!",
        'guidefocusopt': "Hừm! Có vẻ như lựa chọn trước đó của chúng ta không chính xác. Hãy chọn cái còn lại xem sao.",
        'guidefinal': "Ồ! Có vẻ như chúng ta sẽ bắt kịp. Hãy tiếp tục khám phá phần còn lại của câu chuyện nhé.",
        'guidefreesave': "Ôi không! Có vẻ như lựa chọn cuối cùng không chính xác. Hãy giúp Lupin nếu không chúng ta sẽ phải bắt đầu lại từ đầu level.",
        'guidehint': "Nếu bạn chỉ muốn qua màn thì hãy sử dụng gợi ý.",
    },
    'fr_FR': {
        'completed': 'complété',
        'next': 'suivant',
        'level': 'niveau',
        'levels': 'les niveaux',
        'tap to start': 'Appuyez pour commencer',
        'setting': 'réglage',
        'sound': 'sonner',
        'music': 'musique',
        'select level': 'Choisir le niveau',
        'continue': 'Continuez',
        'guideoption': "Oh non! L'amant de Lupin a été kidnappé ! Choisissez l'une des options ci-dessous pour l'aider à chasser le kidnappeur !",
        'guidefocusopt': "Hum ! On dirait que notre sélection précédente était incorrecte. Choisissons l'autre.",
        'guidefinal': "Wow! On dirait que nous allons nous rattraper. Continuons à explorer le reste de l'histoire.",
        'guidefreesave': "Oh non! On dirait que le dernier choix était incorrect. Sauvez Lupin ou nous devrons recommencer depuis le début du niveau.",
        'guidehint': "Si vous voulez juste réussir, utilisez des astuces pour vous aider.",
    },
    'de_DE': {
        'completed': 'abgeschlossen',
        'next': 'Nächster',
        'level': 'Niveau',
        'levels': 'Ebenen',
        'tap to start': 'Tippe, um zu starten',
        'setting': 'Rahmen',
        'sound': 'Klang',
        'music': 'Musik-',
        'select level': 'Stufe auswählen',
        'continue': 'fortsetzen',
        'guideoption': "Ach nein! Lupins Geliebter wurde entführt! Wähle eine der folgenden Optionen, um ihm bei der Verfolgung des Entführers zu helfen!",
        'guidefocusopt': "Hm! Anscheinend war unsere vorherige Auswahl falsch. Wählen wir das andere.",
        'guidefinal': "Beeindruckend! Sieht so aus, als würden wir aufholen. Lassen Sie uns den Rest der Geschichte weiter erkunden.",
        'guidefreesave': "Ach nein! Sieht so aus, als ob die letzte Wahl falsch war. Rette Lupin oder wir müssen von vorne anfangen.",
        'guidehint': "Wenn Sie nur bestehen möchten, verwenden Sie Hinweise, die Ihnen helfen.",
    },
    'th_TH': {
        'completed': 'เสร็จแล้ว',
        'next': 'ต่อไป',
        'level': 'ระดับ',
        'levels': 'ระดับ',
        'tap to start': 'แตะเพื่อเริ่ม',
        'setting': 'การตั้งค่า',
        'sound': 'เสียง',
        'music': 'เพลง',
        'select level': 'เลือกระดับ',
        'continue': 'ต่อ',
        'guideoption': "ไม่นะ! คนรักลูปินโดนลักพาตัว! เลือก 1 ตัวเลือกด้านล่างเพื่อช่วยเขาไล่ตามผู้ลักพาตัว!",
        'guidefocusopt': "อืม! ดูเหมือนว่าการเลือกก่อนหน้านี้ของเราไม่ถูกต้อง มาเลือกอันอื่นกันเถอะ",
        'guidefinal': "ว้าว! ดูเหมือนเราจะทัน มาสำรวจเรื่องราวที่เหลือกันต่อไป",
        'guidefreesave': "ไม่นะ! ดูเหมือนว่าตัวเลือกสุดท้ายจะไม่ถูกต้อง บันทึกลูปินหรือเราจะต้องเริ่มต้นใหม่ตั้งแต่ต้นระดับ",
        'guidehint': "หากคุณต้องการผ่าน ให้ใช้คำใบ้เพื่อช่วยคุณผ่าน",
    },
    'id_ID': {
        'completed': 'lengkap',
        'next': 'lanjut',
        'level': 'tingkat',
        'levels': 'level',
        'tap to start': 'ketuk untuk memulai',
        'setting': 'pengaturan',
        'sound': 'suara',
        'music': 'musik',
        'select level': 'Pilih tingkat',
        'continue': 'terus',
        'guideoption': "Oh tidak! Kekasih Lupin telah diculik! Pilih 1 dari opsi di bawah ini untuk membantunya mengejar si penculik!",
        'guidefocusopt': "Hm! Sepertinya pilihan kami sebelumnya salah. Ayo pilih yang lain.",
        'guidefinal': "Wow! Sepertinya kita akan menyusul. Mari kita lanjutkan menjelajahi sisa cerita.",
        'guidefreesave': "Oh tidak! Sepertinya pilihan terakhir salah. Simpan Lupin atau kita harus memulai dari awal level.",
        'guidehint': "Jika Anda hanya ingin lulus, gunakan petunjuk untuk membantu Anda.",
    },
    'ko_KR': {
        'completed': '완료',
        'next': '다음',
        'level': '수평',
        'levels': '레벨',
        'tap to start': '탭하여 시작',
        'setting': '환경',
        'sound': '소리',
        'music': '음악',
        'select level': '레벨 선택',
        'continue': '계속하다',
        'guideoption': "안 돼! 루팡의 연인이 납치되었습니다! 납치범을 쫓는 데 도움이 되는 옵션 중 하나를 선택하세요!",
        'guidefocusopt': "흠! 이전 선택이 잘못된 것 같습니다. 다른 하나를 선택합시다.",
        'guidefinal': "와! 따라잡을 것 같습니다. 나머지 이야기를 계속 탐색해 보겠습니다.",
        'guidefreesave': "안 돼! 마지막 선택이 잘못된 것 같습니다. Lupine을 구하지 않으면 레벨의 처음부터 다시 시작해야 합니다.",
        'guidehint': "그냥 통과하고 싶다면 힌트를 사용하여 통과하십시오.",
    },
    'CN': {
        'completed': '完全的',
        'next': '下一个',
        'level': '等级',
        'levels': '水平',
        'tap to start': '点击开始',
        'setting': '环境',
        'sound': '声音',
        'music': '音乐',
        'select level': '选择级别',
        'continue': '继续',
        'guideoption': "不好了！ 卢平的情人被绑架了！ 选择以下选项之一来帮助他追捕绑匪！",
        'guidefocusopt': "嗯！ 看起来我们之前的选择不正确。 让我们选择另一个。",
        'guidefinal': "哇！ 看来我们会赶上的。 让我们继续探索故事的其余部分。",
        'guidefreesave': "不好了！ 看起来最后的选择是错误的。 拯救卢平，否则我们将不得不从关卡的开头重新开始。",
        'guidehint': "如果你只是想通过，那么使用提示来帮助你通过。",
    },
    'JP': {
        'completed': '完了',
        'next': '次',
        'level': 'レベル',
        'levels': 'レベル',
        'tap to start': 'タップして開始',
        'setting': '設定',
        'sound': '音',
        'music': '音楽',
        'select level': 'レベルを選択',
        'continue': '継続する',
        'guideoption': "大野！ ルパンの恋人が誘拐されました！ 彼が誘拐犯を追いかけるのを助けるために、以下のオプションの1つを選択してください！",
        'guidefocusopt': "うーん！ 以前の選択が正しくなかったようです。 もう1つ選びましょう。",
        'guidefinal': "わお！ 追いつくようです。 物語の残りの部分を探求し続けましょう。",
        'guidefreesave': "大野！ 最後の選択が間違っていたようです。 ルパンを保存しないと、レベルの最初からやり直す必要があります。",
        'guidehint': "合格したいだけの場合は、ヒントを使用して合格してください。",
    },
    'ES': {
        'completed': 'terminado',
        'next': 'Siguiente',
        'level': 'nivel',
        'levels': 'niveles',
        'tap to start': 'toque para comenzar',
        'setting': 'configuración',
        'sound': 'sonar',
        'music': 'música',
        'select level': 'selecciona el nivel',
        'continue': 'Seguir',
        'guideoption': "¡Oh, no! ¡El amante de Lupin ha sido secuestrado! ¡Elige una de las siguientes opciones para ayudarlo a perseguir al secuestrador!",
        'guidefocusopt': "¡Hm! Parece que nuestra selección anterior era incorrecta. Elijamos el otro.",
        'guidefinal': "¡Guau! Parece que nos pondremos al día. Continuemos explorando el resto de la historia.",
        'guidefreesave': "¡Oh, no! Parece que la última opción fue incorrecta. Salva a Lupin o tendremos que empezar de nuevo desde el principio del nivel.",
        'guidehint': "Si solo quiere aprobar, utilice las sugerencias que le ayudarán a superarlo.",
    },
    'PT': {
        'completed': 'completado',
        'next': 'Next',
        'level': 'nível',
        'levels': 'níveis',
        'tap to start': 'Clique para começar',
        'setting': 'contexto',
        'sound': 'som',
        'music': 'música',
        'select level': 'selecione o nível',
        'continue': 'Prosseguir',
        'guideoption': "Ah não! O amante de Lupin foi sequestrado! Escolha uma das opções abaixo para ajudá-lo a perseguir o sequestrador!",
        'guidefocusopt': "Hm! Parece que nossa seleção anterior estava incorreta. Vamos escolher o outro.",
        'guidefinal': "Uau! Parece que vamos alcançá-lo. Vamos continuar a explorar o resto da história.",
        'guidefreesave': "Ah não! Parece que a última escolha estava incorreta. Salve Lupin ou teremos que recomeçar do início do nível.",
        'guidehint': "Se você quer apenas passar, use as dicas para ajudá-lo.",
    },
    'ar_AR': {
        'completed': 'منجز',
        'next': 'التالي',
        'level': 'مستوى',
        'levels': 'المستويات',
        'tap to start': 'انقر للبدء',
        'setting': 'إعدادات',
        'sound': 'يبدو',
        'music': 'موسيقى',
        'select level': 'اختار مستوى',
        'continue': 'استمر',
        'guideoption': "أوه لا! تم اختطاف حبيب لوبين! اختر أحد الخيارات أدناه لمساعدته في مطاردة الخاطف!",
        'guidefocusopt': "حسنًا! يبدو أن اختيارنا السابق كان غير صحيح. دعونا نختار الآخر.",
        'guidefinal': "رائع! يبدو أننا سنلحق بالركب. دعنا نواصل استكشاف بقية القصة.",
        'guidefreesave': "أوه لا! يبدو أن الخيار الأخير كان غير صحيح. احفظ لوبين وإلا سيتعين علينا البدء من جديد من بداية المستوى.",
        'guidehint': "إذا كنت ترغب في المرور فقط ، فاستخدم التلميحات لمساعدتك.",
    },
    'tr_TR': {
        'completed': 'Tamamlandı',
        'next': 'Sonraki',
        'level': 'seviye',
        'levels': 'seviyeler',
        'tap to start': 'Başlatmak için dokunun',
        'setting': 'ayar',
        'sound': 'ses',
        'music': 'müzik',
        'select level': 'Seviye seç',
        'continue': 'devam et',
        'guideoption': "Oh hayır! Lupin'in sevgilisi kaçırıldı! Adam kaçıranı kovalamasına yardım etmek için aşağıdaki seçeneklerden birini seçin!",
        'guidefocusopt': "Hm! Görünüşe göre önceki seçimimiz yanlıştı. Diğerini seçelim.",
        'guidefinal': "Vay! Yakalayacağız gibi görünüyor. Hikayenin geri kalanını keşfetmeye devam edelim.",
        'guidefreesave': "Oh hayır! Görünüşe göre son seçim yanlıştı. Lupin'i kurtarın yoksa seviyenin başından başlamak zorunda kalacağız.",
        'guidehint': "Sadece geçmek istiyorsanız, size yardımcı olması için ipuçlarını kullanın.",
    },
}